Obj4F:                              ; DATA XREF: ROM:AllObjects↑o
                moveq   #0,d0
                move.b  $24(a0),d0
                move.w  Obj4F_Index(pc,d0.w),d1
                jmp     Obj4F_Index(pc,d1.w)
; ---------------------------------------------------------------------------
Obj4F_Index:
        dc.w Obj4F_Main-Obj4F_Index
        dc.w loc_D246-Obj4F_Index 
        dc.w Obj4F_Move-Obj4F_Index
        dc.w Obj4F_Fall-Obj4F_Index
; ---------------------------------------------------------------------------

Obj4F_Main:                         ; DATA XREF: ROM:Obj4F_Index↑o
                addq.b  #2,$24(a0)
                move.l  #Map_obj4f,4(a0)
                move.w  #$24E4,2(a0)
                move.b  #4,1(a0)
                move.b  #4,$18(a0)
                move.b  #$C,$19(a0)
                move.b  #$14,$16(a0)
                move.b  #2,$20(a0)
                tst.b   $28(a0)         ; Test subtype
                beq.s   loc_D246        ; Subtype 0, branch
                move.w  #$300,d2
                bra.s   Obj4F_CheckRight
; ---------------------------------------------------------------------------

loc_D246:                               ; CODE XREF: ROM:0000D23E↑j
                                        ; DATA XREF: ROM:Obj4F_Index↑o
                move.w  #$E0,d2

Obj4F_CheckRight:                   ; CODE XREF: ROM:0000D244↑j
                move.w  #$100,d1
                bset    #0,1(a0)
                move.w  ($FFFFD008).w,d0 ; Move Sonic's X position to d0
                sub.w   8(a0),d0     ; Check distance between Splats and Sonic
                bcc.s   Obj4F_Left        ; Check if Splats is to the left of Sonic
                neg.w   d0
                neg.w   d1
                bclr    #0,1(a0)

Obj4F_Left:                               ; CODE XREF: ROM:0000D25C↑j
                cmp.w   d2,d0
                bcc.s   Obj4F_Move
                move.w  d1,$10(a0)
                addq.b  #2,$24(a0)

Obj4F_Move:                         ; CODE XREF: ROM:0000D26A↑j
                                        ; DATA XREF: ROM:Obj4F_Index↑o
                bsr.w   ObjectFall
                move.b  #1,$1B(a0)
                tst.w   $12(a0)
                bmi.s   Obj4F_CheckWall
                move.b  #0,$1B(a0)
                bsr.w   ObjHitFloor
                tst.w   d1
                bpl.s   Obj4F_CheckWall
                move.w  (a1),d0
                andi.w  #$3FF,d0
                cmpi.w  #$2D2,d0
                bcs.s   Obj4F_Bounce
                addq.b  #2,$24(a0)
                bra.s   Obj4F_CheckWall
; ---------------------------------------------------------------------------

Obj4F_Bounce:                       ; CODE XREF: ROM:0000D29C↑j
                add.w   d1,$C(a0)
                move.w  #-$400,$12(a0)

Obj4F_CheckWall:                    ; CODE XREF: ROM:0000D282↑j
                                        ; ROM:0000D290↑j ...
                bsr.w   Obj50_ChkWall
                beq.s   Obj4F_Delete
                neg.w   $10(a0)
                bchg    #0,1(a0)
                bchg    #0,$22(a0)

Obj4F_Delete:                       ; CODE XREF: ROM:0000D2B2↑j
                bra.w   MarkObjGone
; ---------------------------------------------------------------------------

Obj4F_Fall:                         ; DATA XREF: ROM:Obj4F_Index↑o
                bsr.w   ObjectFall
                bsr.w   DisplaySprite
                tst.b   1(a0)
                bpl.w   DeleteObject
                rts

Map_obj4f:
                dc.w byte_D310-Map_obj4f
                dc.w byte_D31B-Map_obj4f
                                        ; DATA XREF: ROM:0000D20E↑o
                                        ; !<out unknown/Map_obj4f.map>
byte_D310:      dc.b 2                  ; DATA XREF: ROM:Map_obj4f↑o
                dc.b $EC, $B, 0, 0, $F4
                dc.b $C, 8, 0, $C, $F4
byte_D31B:      dc.b 2                  ; DATA XREF: ROM:Map_obj4f↑o
                dc.b $EC, $B, 0, $F, $F4
                dc.b $C, 4, 0, $1B, $FB ; !<print>!<out>!<ins even>!<part>